Moved out of MatchingTask to make it a standalone object that could be referenced (by scripts for example).

It extends ProjectComponent and thus inherits all methods and properties (not explicitly declared). See ProjectComponent for further detail.

TODO: - merge this with patternsets: FileSet extends PatternSet !!! requires additional mods to the parsing algo [HL] .... not sure if that really makes so much sense. I think that perhaps they should use common utility class if there really is that much shared functionality

author | Hans Lellelid <hans@xmpl.org> (Phing)
author | Arnout J. Kuiper <ajkuiper@wxs.nl> (Ant)
author | Stefano Mazzocchi <stefano@apache.org> (Ant)
author | Sam Ruby <rubys@us.ibm.com> (Ant)
author | Jon S. Stevens <jon@clearink.com> (Ant)
author | Stefan Bodewig <stefan.bodewig@epost.de> (Ant)
author | Magesh Umasankar (Ant)
package | phing.types
version | $Id$

### Methods

## Return a FileSet that has the same basedir and same patternsets as this one.

    __clone()

## __construct()

    __construct($fileset)

### Parameters

#### $fileset

## Add a new selector into this container.

    appendSelector(\FileSelector $selector) : \the

Inherited

inherited_from | \AbstractFileSet::appendSelector()

### Parameters

#### $selector

`\selector`

the new selector to add

### Returns

`\the`selector that was added

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()
inherited_from | \AbstractFileSet::circularReference()

## add an "And" selector entry on the selector list

    createAnd()

Inherited

inherited_from | \AbstractFileSet::createAnd()

## add a contains selector entry on the selector list

    createContains()

Inherited

inherited_from | \AbstractFileSet::createContains()

## add a contains selector entry on the selector list

    createContainsRegexp()

Inherited

inherited_from | \AbstractFileSet::createContainsRegexp()

## add an extended selector entry on the selector list

    createCustom()

Inherited

inherited_from | \AbstractFileSet::createCustom()

## add a selector date entry on the selector list

    createDate()

Inherited

inherited_from | \AbstractFileSet::createDate()

## add a depends selector entry on the selector list

    createDepend()

Inherited

inherited_from | \AbstractFileSet::createDepend()

## add a depth selector entry on the selector list

    createDepth()

Inherited

inherited_from | \AbstractFileSet::createDepth()

## add a name entry on the exclude list

    createExclude()

Inherited

inherited_from | \AbstractFileSet::createExclude()

## add a name entry on the include files list

    createExcludesFile()

Inherited

inherited_from | \AbstractFileSet::createExcludesFile()

## add a selector filename entry on the selector list

    createFilename()

Inherited

inherited_from | \AbstractFileSet::createFilename()

## add a name entry on the include list

    createInclude()

Inherited

inherited_from | \AbstractFileSet::createInclude()

## add a name entry on the include files list

    createIncludesFile()

Inherited

inherited_from | \AbstractFileSet::createIncludesFile()

## add a majority selector entry on the selector list

    createMajority()

Inherited

inherited_from | \AbstractFileSet::createMajority()

## add a "None" selector entry on the selector list

    createNone()

Inherited

inherited_from | \AbstractFileSet::createNone()

## add a "Not" selector entry on the selector list

    createNot()

Inherited

inherited_from | \AbstractFileSet::createNot()

## add an "Or" selector entry on the selector list

    createOr()

Inherited

inherited_from | \AbstractFileSet::createOr()

## createPatternSet()

    createPatternSet()

Inherited

inherited_from | \AbstractFileSet::createPatternSet()

## add a present selector entry on the selector list

    createPresent()

Inherited

inherited_from | \AbstractFileSet::createPresent()

## add a "Select" selector entry on the selector list

    createSelector()

Inherited

inherited_from | \AbstractFileSet::createSelector()

## add a selector size entry on the selector list

    createSize()

Inherited

inherited_from | \AbstractFileSet::createSize()

## add a type selector entry on the selector list

    createType()

Inherited

inherited_from | \AbstractFileSet::createType()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()
inherited_from | \AbstractFileSet::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()
inherited_from | \AbstractFileSet::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()
inherited_from | \AbstractFileSet::getDescription()

## getDir()

    getDir(\Project $p)

Inherited

inherited_from | \AbstractFileSet::getDir()

### Parameters

#### $p

## returns a reference to the dirscanner object belonging to this fileset

    getDirectoryScanner(\Project $p)

Inherited

inherited_from | \AbstractFileSet::getDirectoryScanner()

### Parameters

#### $p

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()
inherited_from | \AbstractFileSet::getProject()

### Returns

`\Project`Reference to current porject object

## Performs the check for circular references and returns the referenced FileSet.

    getRef(\Project $p)

Inherited

inherited_from | \AbstractFileSet::getRef()

### Parameters

#### $p

## Returns the set of selectors as an array.

    getSelectors(\Project $p) : \an

Inherited

inherited_from | \AbstractFileSet::getSelectors()

### Parameters

#### $p

### Returns

`\an`array of selectors in this container

## Indicates whether there are any patterns here.

    hasPatterns() : boolean

Inherited

inherited_from | \AbstractFileSet::hasPatterns()

### Returns

`boolean`Whether any patterns are in this container.

## Indicates whether there are any selectors here.

    hasSelectors() : boolean

Inherited

inherited_from | \AbstractFileSet::hasSelectors()

### Returns

`boolean`Whether any selectors are in this container

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()
inherited_from | \AbstractFileSet::isReference()

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()
inherited_from | \AbstractFileSet::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()
inherited_from | \AbstractFileSet::noChildrenAllowed()

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

Inherited

inherited_from | \DataType::parsingComplete()
inherited_from | \AbstractFileSet::parsingComplete()

## Gives the count of the number of selectors in this container

    selectorCount() : int

Inherited

inherited_from | \AbstractFileSet::selectorCount()

### Returns

`int`The number of selectors in this container

## Returns an array for accessing the set of selectors.

    selectorElements() : array

Inherited

inherited_from | \AbstractFileSet::selectorElements()

### Returns

`array`The array of selectors

## Sets case sensitivity of the file system

    setCaseSensitive($isCaseSensitive)

Inherited

inherited_from | \AbstractFileSet::setCaseSensitive()

### Parameters

#### $isCaseSensitive

## Sets whether default exclusions should be used or not.

    setDefaultexcludes($useDefaultExcludes)

Inherited

inherited_from | \AbstractFileSet::setDefaultexcludes()

### Parameters

#### $useDefaultExcludes

"true"|"on"|"yes" when default exclusions should be used, "false"|"off"|"no" when they shouldn't be used.

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()
inherited_from | \AbstractFileSet::setDescription()

### Parameters

#### $desc

## setDir()

    setDir($dir)

Inherited

inherited_from | \AbstractFileSet::setDir()

### Parameters

#### $dir

## Sets the set of exclude patterns.

    setExcludes($excludes)

Inherited

Patterns may be separated by a comma or a space.

inherited_from | \AbstractFileSet::setExcludes()

### Parameters

#### $excludes

## Sets the name of the file containing the includes patterns.

    setExcludesfile($excl)

Inherited

inherited_from | \AbstractFileSet::setExcludesfile()

### Parameters

#### $excl

The file to fetch the exclude patterns from.

### Exceptions

`\BE` |

## Sets whether to expand/dereference symbolic links, default is false

    setExpandSymbolicLinks($expandSymbolicLinks)

Inherited

var |
inherited_from | \AbstractFileSet::setExpandSymbolicLinks()

### Parameters

#### $expandSymbolicLinks

## Sets the set of include patterns.

    setIncludes($includes)

Inherited

Patterns may be separated by a comma or a space.

inherited_from | \AbstractFileSet::setIncludes()

### Parameters

#### $includes

## Sets the name of the file containing the includes patterns.

    setIncludesfile($incl)

Inherited

inherited_from | \AbstractFileSet::setIncludesfile()

### Parameters

#### $incl

The file to fetch the include patterns from.

### Exceptions

`\BE` |

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()
inherited_from | \AbstractFileSet::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Makes this instance in effect a reference to another PatternSet instance.

    setRefid(\Reference $r) : void

Inherited

You must not set another attribute or nest elements inside this element if you make it a reference.

inherited_from | \AbstractFileSet::setRefid()

### Parameters

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()
inherited_from | \AbstractFileSet::tooManyAttributes()

## feed dirscanner with infos defined by this fileset

    setupDirectoryScanner(\DirectoryScanner $ds, \Project $p)

Inherited

inherited_from | \AbstractFileSet::setupDirectoryScanner()

### Parameters

#### $ds

#### $p

### Properties

##

    $additionalPatterns

Inherited

inherited_from | \AbstractFileSet::$$additionalPatterns

##

    $defaultPatterns : \PatternSet

Inherited

inherited_from | \AbstractFileSet::$$defaultPatterns

##

    $description

Inherited

inherited_from | \DataType::$$description
inherited_from | \AbstractFileSet::$$description

##

    $dir

Inherited

inherited_from | \AbstractFileSet::$$dir

##

    $isCaseSensitive

Inherited

inherited_from | \AbstractFileSet::$$isCaseSensitive

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref
inherited_from | \AbstractFileSet::$$ref

##

    $selectors

Inherited

inherited_from | \AbstractFileSet::$$selectors

##

    $useDefaultExcludes : boolean

Inherited

inherited_from | \AbstractFileSet::$$useDefaultExcludes

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked
inherited_from | \AbstractFileSet::$$checked

##

    $expandSymbolicLinks : boolean

Inherited

inherited_from | \AbstractFileSet::$$expandSymbolicLinks

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project
inherited_from | \AbstractFileSet::$$project